
Foreman - Bug #18587

cannot create or edit subnets and domains in IE11

02/21/2017 07:04 AM - Evgeni Golov

Status: Closed   

Priority: Normal   

Assignee: Evgeni Golov   

Category: Web Interface   

Target version: 1.14.3   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link: 1425094 Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/4313

  

Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1425094

Description of problem:

Satellite 6.2.6

Internet Explorer 11.0.9600.18450 on Windows 8.1

According to 

https://access.redhat.com/documentation/en-us/red_hat_satellite/6.2/html/installation_guide/preparing_your_environment_for_install

ation#supported_browsers.adoc IE11 should work "OK".

When trying to create or edit an existing subnet or domain in Internet Explorer, the browser only shows a 500 error when clicking

submit:

Internal Server Error

The server encountered an internal error or misconfiguration and was unable to complete your request.

Please contact the server administrator at [no address given] to inform them of the time this error occurred, and the actions you

performed just before this error.

More information about this error may be available in the server error log.

When looking at foreman-tail, there is not much to see:

> /var/log/httpd/foreman-ssl_access_ssl.log <

192.0.2.20 - - [20/Feb/2017:14:28:42 +0100] "POST /domains/6-example-example-com HTTP/1.1" 500 531

"https://sat6.example.com/domains" "Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko"

> /var/log/httpd/foreman-ssl_error_ssl.log <

[Mon Feb 20 14:28:42.412067 2017] [ssl:warn] [pid 15416] [client 192.0.2.20:32527] AH02227: Failed to set r->user to

'SSL_CLIENT_S_DN_CN', referer: https://sat6.example.com/domains

[Mon Feb 20 14:28:42.419074 2017] [core:error] [pid 15416] [client 192.0.2.20:32527] End of script output before headers: domains,

referer: https://sat6.example.com/domains   

Especially, there on no POST/PATCH request reaching Foreman.

Compare to a similar request in Firefox:

> /var/log/httpd/foreman-ssl_access_ssl.log <

192.0.2.20 - - [20/Feb/2017:14:34:23 +0100] "POST /domains/4-example-com HTTP/1.1" 302 106

"https://sat6.example.com/domains" "Mozilla/5.0 (Windows NT 6.3; Win64; x64; rv:51.0) Gecko/20100101 Firefox/51.0"

> /var/log/httpd/foreman-ssl_error_ssl.log <

[Mon Feb 20 14:34:23.953415 2017] [ssl:warn] [pid 15414] [client 192.0.2.20:18171] AH02227: Failed to set r->user to

'SSL_CLIENT_S_DN_CN', referer: https://sat6.example.com/domains

[Mon Feb 20 14:34:24.078835 2017] [ssl:warn] [pid 15414] [client 192.0.2.20:18171] AH02227: Failed to set r->user to

'SSL_CLIENT_S_DN_CN', referer: https://sat6.example.com/domains  > /var/log/foreman/production.log <

2017-02-20 14:34:23 [app] [I] Started PATCH "/domains/4-example-com" for 192.0.2.20 at 2017-02-20 14:34:23 +0100

2017-02-20 14:34:23 [app] [I] Processing by DomainsController#update as /*

2017-02-20 14:34:23 [app] [I]   Parameters: {"utf8"=>"?",
"authenticity_token"=>"pxKwq/cmpsg+U1f4P7S+84/XkD8wjPqp8EFzWBSVCKI=", "domain"=>{"name"=>"example.com",

"fullname"=>"sss", "dns_id"=>"", "location_ids"=>["4", "", "3", "5"], "organization_ids"=>["1", ""]}, "id"=>"4-example-com"}

2017-02-20 14:34:24 [app] [I] Redirected to https://sat6.example.com/domains

2017-02-20 14:34:24 [app] [I] Completed 302 Found in 102ms (ActiveRecord: 16.1ms)

2017-02-20 14:34:24 [app] [I] Started GET "/domains" for 192.0.2.20 at 2017-02-20 14:34:24 +0100

2017-02-20 14:34:24 [app] [I] Processing by DomainsController#index as */

2017-02-20 14:34:24 [app] [I]   Rendered domains/index.html.erb within layouts/application (29.9ms)

2017-02-20 14:34:24 [app] [I]   Rendered common/_searchbar.html.erb (5.4ms)

2017-02-20 14:34:24 [app] [I]   Rendered layouts/_application_content.html.erb (6.8ms)

2017-02-20 14:34:24 [app] [I]   Rendered home/_submenu.html.erb (1.6ms)

2017-02-20 14:34:24 [app] [I]   Rendered home/_user_dropdown.html.erb (1.7ms)

2017-02-20 14:34:24 [app] [I] Read fragment views/tabs_and_title_records-3 (0.2ms)

2017-02-20 14:34:24 [app] [I]   Rendered home/_topbar.html.erb (5.1ms)

2017-02-20 14:34:24 [app] [I]   Rendered layouts/base.html.erb (7.0ms)

2017-02-20 14:34:24 [app] [I] Completed 200 OK in 75ms (Views: 45.0ms | ActiveRecord: 8.1ms)  >

/var/log/httpd/foreman-ssl_access_ssl.log <

192.0.2.20 - - [20/Feb/2017:14:34:24 +0100] "GET /domains HTTP/1.1" 200 5478 "https://sat6.example.com/domains" "Mozilla/5.0

(Windows NT 6.3; Win64; x64; rv:51.0) Gecko/20100101 Firefox/51.0"    

Version-Release number of selected component (if applicable):

Satellite 6.2.6, did not test with 6.2.7 or snaps yet.

How reproducible:

100%

Steps to Reproduce:

1. use IE

2. open create/edit dialog for a domain or subnet

3. click submit

Actual results:

error

Expected results:

entry gets created/edited

Additional info:

Related issues:

Related to Foreman - Bug #17808: Editing provisioning templates on Internet E... Closed 12/20/2016

Associated revisions

Revision 8cc2651f - 03/08/2017 04:53 AM - Evgeni Golov

Fixes #18587, #18588 - Fix 'multipart form data' IE bug

According to this bug [1] multipart form data is malformed if there

are fields without names. It been solved within Edge browser, however

no solution is expected for IE10/IE11

It cause a failure with Rack - EOFError: bad content body, therefore

pages like domains and subnet create/edit cannot be submitted (and all

other forms which are submitted via ajax with multipart form data, and

an unnamed field within).

This is identical to https://github.com/theforeman/foreman/pull/4125

but moves the workaround to an own helper function and calls the

function in every submit_or_cancel invocation, thus fixing all forms

which use the two-pane layout.

[1] https://connect.microsoft.com/IE/Feedback/Details/868498

Revision 2227bd55 - 03/28/2017 11:47 AM - Evgeni Golov

Fixes #18587, #18588 - Fix 'multipart form data' IE bug

According to this bug [1] multipart form data is malformed if there

are fields without names. It been solved within Edge browser, however

no solution is expected for IE10/IE11
It cause a failure with Rack - EOFError: bad content body, therefore

pages like domains and subnet create/edit cannot be submitted (and all

other forms which are submitted via ajax with multipart form data, and

an unnamed field within).

This is identical to https://github.com/theforeman/foreman/pull/4125

but moves the workaround to an own helper function and calls the

function in every submit_or_cancel invocation, thus fixing all forms

which use the two-pane layout.

[1] https://connect.microsoft.com/IE/Feedback/Details/868498

(cherry picked from commit 8cc2651fae3caca8eb4b3e574957099148e5266b)

History

#1 - 02/21/2017 07:06 AM - Tomer Brisker

- Related to Bug #17808: Editing provisioning templates on Internet Explorer fails with Internal Server Error added

#2 - 02/21/2017 07:08 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/4313 added

#3 - 03/08/2017 05:01 AM - Anonymous

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 8cc2651fae3caca8eb4b3e574957099148e5266b.

#4 - 03/08/2017 05:15 AM - Dominic Cleal

- Subject changed from cannot create or edit subnets and domains in IE11

 to cannot create or edit subnets and domains in IE11

- Assignee set to Evgeni Golov

- translation missing: en.field_release set to 227
